function [f, df] =  CG_MNIST_alphatSNE_linear(VV, Dim, XX, P, alpha)
% XX contains data, VV contains starting location
% Dim contains dimension

fprintf(1,'CG_dtMCML  called\n');
% t4 = clock;
l1 = Dim(1);
l2 = Dim(2);
l3 = Dim(3);
l4= Dim(4);
l5= Dim(5);
l6= Dim(6);
l7= Dim(7);
l8= Dim(8);
l9= Dim(9);
N = size(XX,1);

% Do deconversion.
 w1 = reshape(VV(1:(l1+1)*l2),l1+1,l2);
 xxx = (l1+1)*l2;
 w2 = reshape(VV(xxx+1:xxx+(l2+1)*l3),l2+1,l3);
 xxx = xxx+(l2+1)*l3;
 w3 = reshape(VV(xxx+1:xxx+(l3+1)*l4),l3+1,l4);
 xxx = xxx+(l3+1)*l4;
 w4 = reshape(VV(xxx+1:xxx+(l4+1)*l5),l4+1,l5);
 xxx = xxx+(l4+1)*l5;
 w5 = reshape(VV(xxx+1:xxx+(l5+1)*l6),l5+1,l6);
 xxx = xxx+(l5+1)*l6;
 w6 = reshape(VV(xxx+1:xxx+(l6+1)*l7),l6+1,l7);
 xxx = xxx+(l6+1)*l7;
 w7 = reshape(VV(xxx+1:xxx+(l7+1)*l8),l7+1,l8);
 xxx = xxx+(l7+1)*l8;
 w8 = reshape(VV(xxx+1:xxx+(l8+1)*l9),l8+1,l9);


  XX = [XX ones(N,1)];
  w1probs = 1./(1 + exp(-XX*w1)); w1probs = [w1probs  ones(N,1)];
  w2probs = 1./(1 + exp(-w1probs*w2)); w2probs = [w2probs ones(N,1)];
  w3probs = 1./(1 + exp(-w2probs*w3)); w3probs = [w3probs  ones(N,1)];
  w4probs = w3probs*w4; w4probs = [w4probs  ones(N,1)];
  
  % comment out upper layers for autoencoder
  %w5probs = 1./(1 + exp(-w4probs*w5)); w5probs = [w5probs  ones(N,1)];
  %w6probs = 1./(1 + exp(-w5probs*w6)); w6probs = [w6probs  ones(N,1)];
  %w7probs = 1./(1 + exp(-w6probs*w7)); w7probs = [w7probs  ones(N,1)];
  %XXout = 1./(1 + exp(-w7probs*w8));
w5probs = eye(N, l6+1);
w6probs = eye(N, l7+1);
w7probs = eye(N, l8+1);
XXout = eye(N, l9);

ydata = w4probs(:,1:(size(w4probs, 2)-1));


        new_code_grad2 = zeros(size(ydata));

        % Compute joint probability that point i and j are neighbors
        sum_ydata = sum(ydata .^ 2, 2);                                                % precomputation for pairwise distances
        oldnum = 1./(1 + (bsxfun(@plus, sum_ydata, bsxfun(@plus, sum_ydata', -2 * ydata * ydata')))/alpha);  
        num = oldnum.^(0.5+alpha*0.5);
        % Student-t distribution
        num(1:N+1:end) = 0;  
        oldnum(1:N+1:end) = 0;   
      % set diagonal to zero
        Q = num ./ sum(num(:));                                                        % normalize to get probabilities
        Q = max(Q, eps);

        % Compute the gradients
        stiffnesses = (2*alpha+2)/alpha * (P - Q) .* oldnum;
        for i=1:N
            new_code_grad2(i,:) = sum(bsxfun(@times, bsxfun(@minus, ydata(i,:), ydata), stiffnesses(:,i)), 1);
        end


% Normalize?
%length_triples = size(triples, 1);


err2 = sum(sum(-P.*log(Q)));

f = err2;

%IO = lambda1*1/N*(XXout-XX(:,1:end-1));
%Ix8=IO; 
dw8 =  eye(l8+1, l9);
                                                % Does back propagation to
                                                % get dw's
%Ix7 = (Ix8*w8').*w7probs.*(1-w7probs); 
%Ix7 = Ix7(:,1:end-1);
dw7 =  eye(l7+1,l8);

%Ix6 = (Ix7*w7').*w6probs.*(1-w6probs); 
%Ix6 = Ix6(:,1:end-1);
dw6 =  eye(l6+1,l7);

%Ix5 = (Ix6*w6').*w5probs.*(1-w5probs); 
%Ix5 = Ix5(:,1:end-1);
dw5 =  eye(l5+1,l6);


% Ix4 = (Ix5*w5');
% Ix4 = Ix4(:,1:end-1);
% Ix4 = Ix4(:,1:end-1) + new_code_grad*lambda2;
 
% only use supervised tSNE cost
Ix4 = new_code_grad2;

dw8=dw8*0;dw7=dw7*0;dw6=dw6*0;dw5=dw5*0;% Uncomment to turn off reconstructive tuning
dw4 =  w3probs'*Ix4;


Ix3 = (Ix4*w4').*w3probs.*(1-w3probs); 
Ix3 = Ix3(:,1:end-1);
dw3 =  w2probs'*Ix3;

Ix2 = (Ix3*w3').*w2probs.*(1-w2probs); 
Ix2 = Ix2(:,1:end-1);
dw2 =  w1probs'*Ix2;

Ix1 = (Ix2*w2').*w1probs.*(1-w1probs); 
Ix1 = Ix1(:,1:end-1);
dw1 =  XX'*Ix1;



df = [dw1(:)' dw2(:)' dw3(:)' dw4(:)' dw5(:)' dw6(:)'  dw7(:)'  dw8(:)'  ]';    % Returns vector of partial derivatives WRT the weights
clear Ix* XX* xx* w* l* qvals P Q new_code_grad2 ydata sum_ydata tiffnesses;
