
% Version 1.000
%
% initmaxepoch


% This program pretrains a deep autoencoder for MNIST dataset
% You can set the maximum number of epochs for pretraining each layer
% and you can set the architecture of the multilayer net.

initmaxepoch=50; 
numhid=500; numpen=500; numpen2=2000; numopen=30;    

NUMHID = numhid;

fprintf(1,'Pretraining a deep autoencoder. \n');

[numcases numdims numbatches]=size(batchdata);

fprintf(1,'Pretraining Layer 1 with RBM: %d-%d \n',numdims,numhid);
restart=1;
maxepoch = initmaxepoch;
rbm;
hidrecbiases=hidbiases; 
save(['mnistvh' '_' int2str(NUMHID) '_' int2str(numpen) '_' int2str(numpen2) '_' int2str(numopen) 'ep' '_' int2str(initmaxepoch)], ...
'vishid', 'hidrecbiases', 'visbiases');

fprintf(1,'\nPretraining Layer 2 with RBM: %d-%d \n',numhid,numpen);
batchdata=batchposhidprobs;
numhid=numpen;
restart=1;
maxepoch = initmaxepoch;
rbm;
hidpen=vishid; penrecbiases=hidbiases; hidgenbiases=visbiases;
save( ['mnisthp' '_' int2str(NUMHID) '_' int2str(numpen) '_' int2str(numpen2) '_' int2str(numopen) 'ep' '_' int2str(initmaxepoch)], ...
		 'hidpen', 'penrecbiases', 'hidgenbiases');

fprintf(1,'\nPretraining Layer 3 with RBM: %d-%d \n',numpen,numpen2);
batchdata=batchposhidprobs;
numhid=numpen2;
maxepoch = initmaxepoch;
restart=1;
rbm;
hidpen2=vishid; penrecbiases2=hidbiases; hidgenbiases2=visbiases;
save(['mnisthp2' '_' int2str(NUMHID) '_' int2str(numpen) '_' int2str(numpen2) '_' int2str(numopen) 'ep' '_' int2str(initmaxepoch)], ...
		 'hidpen2', 'penrecbiases2', 'hidgenbiases2','batchposhidprobs');

fprintf(1,'\nPretraining Layer 4 with RBM: %d-%d \n',numpen2,numopen);
batchdata=batchposhidprobs;
numhid=numopen; 
restart=1;
maxepoch = initmaxepoch;
rbmhidlinear;
hidtop=vishid; toprecbiases=hidbiases; topgenbiases=visbiases;
save(['mnistpo' '_' int2str(NUMHID) '_' int2str(numpen) '_' int2str(numpen2) '_' int2str(numopen) 'ep' '_' int2str(initmaxepoch)], ...
  'hidtop', 'toprecbiases', 'topgenbiases');
